;/*----------------------------------------------*/
;/* demo for scrolling the client area           */
;/*  - client size = 300x200                     */
;/*  - hDrawDC is used for drawing the function  */
;/*  - hDrawDC = 1000x200 pixels                 */
;/*----------------------------------------------*/

include masm32rt.inc
.data?
    hInstance   HINSTANCE	?
    hDrawDC		HDC			?
.code
WndProc proto hWnd:HWND,uMgs:UINT,wParam:WPARAM,lParam:LPARAM
DrawFnc proto
AdjustWnd proto hWnd:HWND,nx:DWORD,ny:DWORD

main proc
LOCAL wc:WNDCLASSEX
LOCAL msg:MSG

    mov hInstance,rv(GetModuleHandle,0)
    mov wc.hInstance,eax
    mov wc.cbSize,SIZEOF wc
    mov wc.style,CS_HREDRAW or CS_VREDRAW or CS_SAVEBITS
    mov wc.lpfnWndProc,OFFSET WndProc
    mov wc.cbClsExtra,0
    mov wc.cbWndExtra,0
    mov wc.hIcon,rv(LoadIcon,0,IDI_APPLICATION)
    mov wc.hIconSm,eax
    mov wc.hCursor,rv(LoadCursor,0,IDC_ARROW)
    mov wc.lpszMenuName,0
    mov wc.hbrBackground,0;
    mov wc.lpszClassName,chr$("Win32Wnd")
    invoke RegisterClassEx,ADDR wc
    mov esi,rv(CreateWindowEx,0,wc.lpszClassName,"Win32Wnd",WS_VISIBLE or WS_SYSMENU or WS_MAXIMIZEBOX or WS_MINIMIZEBOX or WS_HSCROLL,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,0,0,hInstance,0)
    invoke UpdateWindow,esi 
    
    .while 1
        invoke GetMessage,ADDR msg,0,0,0
        .break .if !eax || eax == -1
        invoke TranslateMessage,ADDR msg
        invoke DispatchMessage,ADDR msg     
    .endw

    invoke ExitProcess,0
main endp

WndProc proc hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
LOCAL hdc:HDC
LOCAL ps:PAINTSTRUCT
LOCAL sci:SCROLLINFO

    .if uMsg == WM_CLOSE
        invoke PostQuitMessage,0
        
	.elseif uMsg == WM_CREATE
		mov hdc,rv(GetDC,rv(GetDesktopWindow))
		mov hDrawDC,rv(CreateCompatibleDC,hdc)
		invoke DeleteObject,rv(SelectObject,hDrawDC,rv(CreateCompatibleBitmap,hdc,1000,200))
		invoke DeleteObject,rv(SelectObject,hDrawDC,rv(CreatePen,PS_SOLID,2,0ffffh))
		invoke ReleaseDC,rv(GetDesktopWindow),hdc
		invoke DrawFnc
		mov sci.cbSize,SIZEOF sci
		mov sci.fMask,SIF_ALL
		mov sci.nMin,0
		mov sci.nMax,1000-1
		mov sci.nPage,300
		mov sci.nPos,0
		mov sci.nTrackPos,0
		invoke SetScrollInfo,hWnd,SB_HORZ,ADDR sci,1
		invoke AdjustWnd,hWnd,300,200		

	.elseif uMsg == WM_HSCROLL
		mov sci.cbSize,SIZEOF sci
		mov sci.fMask,SIF_ALL		
		invoke GetScrollInfo,hWnd,SB_HORZ,ADDR sci
		switch WORD ptr wParam , ax
		case SB_BOTTOM
			mov edx,sci.nMax		
		case SB_ENDSCROLL
			mov edx,sci.nPos
		case SB_LINELEFT
			mov edx,sci.nPos
			lea edx,[edx-1]
		case SB_LINERIGHT
			mov edx,sci.nPos
			lea edx,[edx+1]
		case SB_PAGELEFT
			mov edx,sci.nPos
			lea edx,[edx-300]
		case SB_PAGERIGHT
			mov edx,sci.nPos
			lea edx,[edx+300]
		case SB_THUMBPOSITION
			movzx edx,WORD ptr wParam+2
		case SB_THUMBTRACK
			movzx edx,WORD ptr wParam+2
		case SB_TOP
			mov edx,sci.nMin
		default
			xor eax,eax
			ret
		endsw
		mov sci.nPos,edx
		mov sci.fMask,SIF_POS
		invoke SetScrollInfo,hWnd,SB_HORZ,ADDR sci,1
		invoke InvalidateRect,hWnd,0,1
		
	.elseif uMsg == WM_PAINT
		invoke BeginPaint,hWnd,ADDR ps
		mov sci.cbSize,SIZEOF sci
		mov sci.fMask,SIF_POS		
		invoke GetScrollInfo,hWnd,SB_HORZ,ADDR sci
		sub ASM(mov edx,ps.rcPaint.right),ps.rcPaint.left
		sub ASM(mov ecx,ps.rcPaint.bottom),ps.rcPaint.top
		inc edx
		inc ecx
		invoke BitBlt,ps.hdc,ps.rcPaint.left,ps.rcPaint.top,edx,ecx,hDrawDC,sci.nPos,ps.rcPaint.top,SRCCOPY		
		invoke EndPaint,hWnd,ADDR ps
    .else
        invoke DefWindowProc,hWnd,uMsg,wParam,lParam
        ret
    .endif
    xor eax,eax
    ret
WndProc endp

;/* draw some function */
DrawFnc proc uses edi
LOCAL xscale:REAL4
LOCAL yscale:REAL4
	
	mov edi,alloc(1000*SIZEOF POINT)

	finit
	fld FP4(0.6)
	fld FP4(-50.0)
	
	fld FP4(1000.0)
	fld FP4(200.0)
	fdiv FP4(150.0)
	fstp yscale
	fdiv FP4(100.0)
	fstp xscale

	xor ecx,ecx
	.while ecx < 1000
		fld st
		fadd FP4(50.0)
		fmul xscale
		fistp [edi+ecx*SIZEOF POINT].POINT.x
		fld st
		fmul st,st
		fmul FP4(0.03)
		fld st(1)
		fsin
		fmul FP4(10.0)
		faddp st(1),st
		fadd FP4(50.0)
		fmul yscale
		fld FP4(200.0)
		fsubrp st(1),st
		fistp [edi+ecx*SIZEOF POINT].POINT.y
		fadd st(0),st(1)
		inc ecx
	.endw
	
	fstp st
	fstp st
	
	invoke Polyline,hDrawDC,edi,1000	
	
	ret

DrawFnc endp

;/* set client area size */
AdjustWnd proc hWnd:HWND,nx:DWORD,ny:DWORD
LOCAL rect[2]:RECT	
	
	invoke GetClientRect,hWnd,ADDR rect
	invoke GetWindowRect,hWnd,ADDR rect[16]
	mov eax,rect[16].left
	sub rect[16].right,eax
	mov eax,rect[16].top
	sub rect[16].bottom,eax
	
	mov eax,nx
	sub eax,rect.right
	mov edx,ny
	sub edx,rect.bottom

	add rect[16].right,eax
	add rect[16].bottom,edx
	invoke SetWindowPos,hWnd,0,0,0,rect[16].right,rect[16].bottom,SWP_NOMOVE or SWP_NOZORDER	
	ret

AdjustWnd endp
end main